SystemOrganization addCategory: #'IRDA2013-Searching'!
SystemOrganization addCategory: #'IRDA2013-Searching-Tests'!

CircleMorph subclass: #I2SVisualNode
	instanceVariableNames: 'node parent visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 15:25:40.439'!
blankNodeWidth
	^40! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:10:59.158'!
defaultNodeColor

	^Color orange ! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 12:19:35.238'!
levelHeight
	^20! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 14:31:07.786'!
newWithNode: aNode on: aVisualization
	| a |
	a := self new.
	a node: aNode.
	a visualization: aVisualization.
	a visualization setVisualNode: a for: aNode.
	
	a draw.	
	aNode hasChildren ifTrue: [
		a drawChildren.
	].
	a setupEventListeners.
	
	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:12:19.625'!
newWithNode: aNode renderDepth: aNumber on: aVisualization
	| a |
	a := self new.
	a node: aNode.
	a visualization: aVisualization.
	a visualization setVisualNode: a for: aNode.
	
	a draw.
	((aNumber > 1) and: (aNode hasChildren)) ifTrue: [
		a drawChildrenWithDepth: aNumber. 
	].
	"a bounds: a fullBounds."
	a setupEventListeners.

	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 17:02:39.699'!
nodeSpace
	^20! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:57:39.452'!
arrangeChildren: children withOffset: offset
	| o |

	o := offset.

	children do: [:child |
		child isNil ifTrue: [
			o := o + self class blankNodeWidth + self class nodeSpace.
		] 
		ifFalse: [
			|x y|
			"x := (offset + (child fullBounds width / 2))."
			x := (o + (0 - (child fullBounds topLeft x))).
			y := self class levelHeight + self bounds height.
			child position: x@y.
			o := o + child fullBounds width + self class nodeSpace.
			self addMorph: child.
			"the line"
			self addMorph: (LineMorph 
					from: self bounds bottomCenter 
					to: child bounds topCenter
					color: Color black 
					width: 5). 
		]
	].! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:20:13.994'!
calculateOffset: children
	| totalWidth l r b |

	"documented on https://rialgar.de/IRDA2013Doku/page.xhtml"

	totalWidth := self calculateTotalWidth: children.
	
	l := 0. r := 0. b := 0.
	
	(children first) ifNotNil: [
		l := 0 - ((children first) fullBounds left).
	].
	(children last)  ifNotNil:[
		r := ((children last fullBounds right) - (children last bounds right)).
	].
	b := self bounds width.
	
	^ 0 - ((totalWidth+l-r-b)/2).! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:04:50.051'!
calculateTotalWidth: children
	| totalWidth |
	totalWidth := 0.
	
	children do:[ :child |
			child isNil ifTrue: [
				totalWidth := totalWidth + self class blankNodeWidth.
			] ifFalse: [
				totalWidth := totalWidth + (child fullBounds width).
			].
		].
	
	"between childs there should be some space, so we add this to the total width"
	totalWidth := totalWidth + (((children size) - 1) * self class nodeSpace).
	
	^totalWidth! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 18:12:57.559'!
draw
	(node color) ifNotNil:
		[self color: node color]
	ifNil:
		[self color: 
			self class defaultNodeColor].
	self drawValue.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:02:51.694'!
drawChildren 
	self drawChildrenWithDepth: Float infinity.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:27:17.271'!
drawChildrenWithDepth: aNumber 
	| children offset |
	children := self gatherChildrenWithDepth: aNumber.
	
	offset := self calculateOffset: children.
	
	self arrangeChildren: children withOffset: offset.
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 14:30:11.745'!
drawValue
	| textMorph |
	textMorph := TextMorph new.
	textMorph contents: (((self node getValueAt: 1) asString) truncateTo: 4).
	textMorph lock: true.
	self addMorph: textMorph.
	textMorph position: 10@10.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:09:51.605'!
gatherChildrenWithDepth: aNumber
	| children |
	children := OrderedCollection new.
	
	(node children) 
		do: [ :child || a |
			child isNil 
			ifTrue: [
				children add: nil.
			] 
			ifFalse: [
				a := self class newWithNode: child renderDepth: (aNumber - 1) on: self visualization.
				children add: a.
			].
		].
	
	^children.
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:50.635'!
node
 ^node! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:54.969'!
node: aNode
 node := aNode! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 18:24:41.457'!
onMouseEnter
	Transcript showln: 'Foobar'.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 18:35:32.453'!
onMouseEnter: evt
	evt wasHandled: true.
	Transcript showln: 'foo'.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:32:37.503'!
parent
	^parent! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:32:27.117'!
parent: aMorph
	parent := aMorph.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 18:54:57.496'!
setupEventListeners 
	"self on: #mouseEnter send: #onMouseEnter: to: self."
	self balloonText: (self node getValueAt: 1) asString."
	self addMorph: (BalloonMorph string: ((self node getValueAt: 1) asString) for: self corner: #topLeft)."! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:24:24.415'!
visualization 
	
	^visualization
	! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:24:45.659'!
visualization: aVisualization
	
	visualization := aVisualization.
	! !

Morph subclass: #I2SListElementMorph
	instanceVariableNames: 'active value text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:21:29.105'!
activate
	self owner activeElement: self.
	active := true.
	text color: Color black.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:47:39.195'!
alignText
	text position: ((self extent - text extent) / 2).! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:56:25.359'!
buildText
	text := TextMorph new.
	text contents: (value asString).
	text lock: true.
	text color: Color transparent.
	self addMorph: text.
	self alignText.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:15:23.053'!
deactivate
	active := false.
	text color: Color transparent.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:53.6'!
defaultBounds
	^0@0 corner: 50@50! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:11:09.039'!
initialize
	super initialize.
	
	self borderWidth: 1.
	self borderColor: Color black.
	self color: Color white.
	
	active := false.
	value := 0.
	self buildText.
	
	self on: #click send: #onClick to: self.
	self on: #mouseEnter send: #onMouseEnter to: self.
	self on: #mouseLeave send: #onMouseLeave to: self.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:13:46.547'!
onClick
	active ifFalse: [
		self activate.
	] ifTrue: [
		self deactivate.
	]! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:03:08.98'!
onMouseEnter
	self color: Color yellow muchLighter.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:01:32.792'!
onMouseLeave
	self color: Color white.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:28:11.813'!
value
	^value! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:36:28.677'!
value: aValue.
	value := aValue.
	text contents: aValue asString.
	self alignText.! !

Morph subclass: #I2SListMorph
	instanceVariableNames: 'activeElement list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListMorph class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:05.82'!
newWithList: aList
	|out|
	
	out := self new.
	out list: aList.
	
	^out! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:00.362'!
activeElement
	^activeElement! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:16:57.403'!
activeElement: anElement.
	activeElement ifNotNil:[
		activeElement deactivate.	
	].
	activeElement := anElement.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:38:28.815'!
draw
	| offset |
	
	offset := 0.
	
	list do: [:ea| |morph|
		morph := I2SListElementMorph new.
		morph value: ea.
		morph left: offset.
		self addMorph: morph.
		offset := offset + morph width.].
	
	self extent: self fullBounds extent.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:37:22.371'!
initialize
	super initialize.
	list := #().
	self color: Color transparent.
	self borderWidth: 1.
	self borderColor: Color black.
	
	activeElement := nil.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:02.53'!
list
	^list! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 12:01:35.303'!
list: aList.
	list := aList.! !

Morph subclass: #I2SVisualization
	instanceVariableNames: 'rootNode visualNodeMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SVisualization subclass: #I2STreeSectionMorph
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STreeSectionMorph class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 15:40:36.914'!
newWithNode: aNode
 | a |
	a := self new.
	a color: Color transparent.
	a node: aNode.
	a draw.
	^a! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:40:12.198'!
draw
	self removeAllMorphs.
	
	self drawCurrentNode.
	
	self node leftChild ifNotNil: [
		self drawLeftChild.
	].
	
	self node rightChild ifNotNil: [
		self drawRightChild.
	].
	
	self node parent ifNotNil: [
		self drawParentNode.
	].

	self extent: 100@160.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:15:07.75'!
drawCurrentNode
	| activeNodeMorph |
	activeNodeMorph := (I2SVisualNode newWithNode: self node renderDepth: 1 on: self).
	self addMorph: activeNodeMorph.
	activeNodeMorph position: (self position + (30@60)).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:15:51.831'!
drawLeftChild
	| leftVis |
	leftVis := (I2SVisualNode newWithNode: self node leftChild renderDepth: 1 on: self).
	self addMorph: leftVis.
	leftVis position: (self position + (0@120)).
	self addMorph: (LineMorph 
		from: (self position + (50@100)) 
		to: (self position + (20@120))
		color: Color black 
		width: 5). 
	leftVis on: #click send: #goLeft to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:16:02.668'!
drawParentNode
	| parentVis |
	parentVis := (I2SVisualNode newWithNode: self node parent renderDepth: 1 on: self).
	self addMorph: parentVis.
	parentVis position: (self position + (30@0)).
	self addMorph: (LineMorph 
		from: (self position + (50@60)) 
		to: (self position + (50@40))
		color: Color black
		width: 5).
	parentVis on: #click send: #goUp to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:15:56.092'!
drawRightChild
	| rightVis |
	rightVis := (I2SVisualNode newWithNode: self node rightChild renderDepth: 1 on: self).
	self addMorph: rightVis.
	rightVis position: (self position + (60@120)).
	self addMorph: (LineMorph 
		from: (self position + (50@100)) 
		to: (self position + (80@120))
		color: Color black 
		width: 5). 
	rightVis on: #click send: #goRight to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 15:24:21.38'!
goLeft
	self node: self node leftChild.
	self draw.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 15:27:24.108'!
goRight
	self node: self node rightChild.
	self draw.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 14:46:00.472'!
goUp
	self node: self node parent.
	self draw.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 11:32:06.562'!
node
	^node! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 11:34:27.875'!
node: aNode
 node := aNode.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:18:17.805'!
setRootNode: aNode
	self node: aNode.! !

!I2SVisualization class methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:35:08.134'!
newWithNode: aNode

  	|a visNode |
  	a := self new.
	a setRootNode: aNode.
	
	^a
  ! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:22:10.297'!
addedChild: aNode to: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:52.204'!
getVisualNodeFor: aTreeNode

	^visualNodeMap at: aTreeNode ifAbsent: nil! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:59:34.593'!
initialize 
	super initialize.
	visualNodeMap := Dictionary new.
	color := Color transparent.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:33:12.866'!
removedChild: aNode from: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:55.22'!
rootNode
	^rootNode! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:11:04.226'!
rootNode: aNode
	rootNode := aNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:32:49.965'!
setRootNode: aRoot

	| visNode |
	self rootNode: aRoot.

  	visNode := (I2SVisualNode newWithNode: aRoot on: self).
  	self addMorph: visNode.
	visNode visualization: self.
  	self extent: visNode fullBounds extent.
	visNode position: visNode position - self fullBounds topLeft.
	
	visualNodeMap at: aRoot put: visNode .

  	self position: ActiveWorld visibleClearArea origin.

 	self setupConnections.
  	^self! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 14:33:29.818'!
setVisualNode: aVisNode for: aTreeNode

	visualNodeMap at: aTreeNode put: aVisNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:32:57.414'!
setupConnections

	self connect: self rootNode signal: #addedChild:to:at: toSelector: #addedChild:to:at:.
	
	self connect: self rootNode signal: #removedChild:from:at: toSelector: #removedChild:from:at:.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 11:24:23.274'!
updateTree
	| visNode |
	self removeAllMorphs.
	visNode := (I2SVisualNode newWithNode:  self rootNode on: self).
  self addMorph: visNode.
  self bounds: visNode fullBounds.
  visNode position: 0@0.
  self position: ActiveWorld visibleClearArea origin.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:54:42.404'!
visualNodeMap
	
	^visualNodeMap! !

Object subclass: #I2STestNode
	instanceVariableNames: 'value children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:37:45.65'!
children
	^children! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:38:00.496'!
children: anOrderedCollection
	children := anOrderedCollection! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:38:05.751'!
initialize

	self children: OrderedCollection new! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:39:05.903'!
value 
 ^value! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:39:11.427'!
value: aValue
 value := aValue! !

Object subclass: #I2STreeNode
	instanceVariableNames: 'parent children numChildren values maxChildren maxValues color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STreeNode subclass: #I2SBinaryTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SBinaryTreeNode subclass: #I2SBinarySearchTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:13:37.331'!
addValue: aValue

	(self value > aValue) ifTrue:[
		self leftChild ifNil: [
				self leftChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self leftChild addValue: aValue.
			].
		]ifFalse:[
			self rightChild ifNil: [
				self rightChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self rightChild addValue: aValue.
			].
		]! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:56:17.112'!
find: aValue

	^(self findNodeForValue: aValue) isNil not! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:06.472'!
findNodeForValue: aValue

	(self value = aValue) ifTrue: [
		^self
	] ifFalse: [
		(self value > aValue) ifTrue:[
			self leftChild ifNil: [
				^nil
			] ifNotNil: [
				^self leftChild findNodeForValue: aValue
			]
		] ifFalse:[
			self rightChild ifNil: [
				^nil
			] ifNotNil: [
				^self rightChild findNodeForValue: aValue
			]
		]
	].! !

!I2SBinarySearchTreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 5/15/2013 11:06:37.881'!
initialize

	super initialize.! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:30:16.149'!
leftMostAncestor 
	self leftChild ifNil: [
		^self
	] ifNotNil: [
		^self leftChild leftMostAncestor
	].! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:31:02.453'!
remove: aValue
	| node |
	
	node := self findNodeForValue: aValue.
	node ifNotNil:[
		node rightChild ifNil:[ | child |
			child := node leftChild.
			node leftChild: nil.
			node parent replace: node with: child.
		] ifNotNil: [
			node leftChild ifNil:[ | child |
				child := node rightChild.
				node rightChild: nil.
				node parent replace: node with: child.
			] ifNotNil:[ | leaf child |
				leaf := node rightChild leftMostAncestor.
				node value: leaf value.
				child := leaf rightChild.
				leaf rightChild: nil.
				leaf parent replace: leaf with: child.
			]
		]
	]! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:34:28.432'!
initialize

	super initialize.
	self maxChildren: 2.
	self maxValues: 1.
	self children add: nil.
	self children add: nil.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:37.869'!
leftChild

	^self getChildAt: 1! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:17.767'!
leftChild: aNode

	self leftChild ifNotNil: [
		self removeChildAt: 1.].
	
	aNode ifNotNil:[
		self addChild: aNode at: 1.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:40.078'!
rightChild

	^self getChildAt: 2! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:25.394'!
rightChild: aNode
	
	self rightChild ifNotNil:[
		self removeChildAt: 2.].
	aNode ifNotNil:[
		self addChild: aNode at: 2.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:42.497'!
value
	^self getValueAt: 1! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:38:34.794'!
value: aValue
	self setValue: aValue at: 1.! !

!I2STreeNode class methodsFor: 'constructors' stamp: 'benjamin.siegmund 5/29/2013 16:46:43.51'!
newWithValue: aValue
	| out |
	out := self new.
	out setValue: aValue at: 1.
	^out! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/15/2013 11:22:09.258'!
addChild: newRoot at: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].

	newRoot parent ifNotNil: [
		self error: 'node already has a parent'].

	[children size < position] whileTrue: [
		children add: nil].

	(children at: position) ifNil: [
		children at: position put: newRoot.
		newRoot parent: self.
		 self
			connect: newRoot
			signal: #addedChild:to:at:
			toSelector: #fireAddedChild:to:at:.
		self
			connect: newRoot
			signal: #removedChild:from:at:
			toSelector: #fireRemovedChild:from:at:.
		self addedChild: newRoot to: self at: position.
		numChildren := numChildren+1.] ifNotNil: [
		self error: 'child already present.'
		].! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 5/2/2013 15:42:15.911'!
addedChild: newRoot to: parent at: position

self emit.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:07.532'!
children

^children! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:06:57.034'!
color

	^color! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:06:13.238'!
color: aColor
	
	color := aColor.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:18:41.375'!
fireAddedChild: newRoot to: parent at: position

self addedChild: newRoot to: parent at: position.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:19:01.382'!
fireRemovedChild: root from: parent at: position

self removedChild: root from: parent at: position.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 12:38:13.762'!
getChildAt: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].

	children size >= position ifTrue: [
		^children at: position] ifFalse: [
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:47:52.104'!
getValueAt: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'].

	(values size >= position) ifTrue: [
		^values at: position] ifFalse:[
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:24.062'!
hasChildren

^numChildren > 0! !

!I2STreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 5/8/2013 14:02:08.986'!
initialize

	parent := nil.
	children := OrderedCollection new.
	values := OrderedCollection new.
	numChildren := 0.
	maxChildren := 10.
	maxValues := 9.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:35.244'!
maxChildren

	^maxChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:56:18.137'!
maxChildren: aNumber

	maxChildren := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:37.916'!
maxValues

	^maxValues! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:55:05.223'!
maxValues: aNumber

	maxValues := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:30.94'!
numChildren

^numChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:40.214'!
parent

	^parent! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 14:02:41.641'!
parent: aNode

	parent := aNode.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/15/2013 11:22:26.382'!
removeChildAt: position
(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].
	
children size >= position ifTrue: [
	(children at: position) ifNotNil:[
		| child |
		child := children at: position.
		children at: position put: nil.
		child parent: nil.
		child
			disconnectSignal: #addedChild:to:at:
			from: self
			selector: #fireAddedChild:to:at:.
		child
			disconnectSignal: #removedChild:from:at:
			from: self
			selector: #fireRemovedChild:from:at:.
		self removedChild: child from: self at: position.
		numChildren := numChildren-1.]]! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 5/8/2013 12:32:19.327'!
removedChild: root from: parent at: position

self emit.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:27:04.935'!
replace: child with: newChild
	1 to: children size do: [ :i |
		((self children	at: i) = child) ifTrue: [
			self removeChildAt: i.
			self addChild: newChild at: i.
		] 
	]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:53:59.231'!
setValue: aValue at: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'.].

	[values size < position] whileTrue: [
		values add: nil].

	values at: position put: aValue.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 17:37:22.205'!
visualization: aVisualNode

	visualization := aVisualNode.! !

TestCase subclass: #I2SListMorphTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:51:21.506'!
setUp
	super setUp.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:51:30.449'!
tearDown
	super tearDown.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:54:28.164'!
test01length
	| a list r |
	r := Random new.
	a := r next: 20.
	a sort.
	list := I2SListMorph newWithList: a.
	list draw.
	self assert: 20 equals: (list submorphs size).! !

TestCase subclass: #I2STreeNodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:18:11.279'!
setUp
	super setUp.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:26:52.118'!
tearDown
	super tearDown.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 12:45:48.174'!
test01Initialisation
	| a |
	a := I2STreeNode newWithValue: #a.
	self assert: #a equals: (a getValueAt: 1).
	self assert: (a hasChildren) not.
	self assert: 0 equals: (a numChildren).! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:54:01.813'!
test02Limits
	| a |
	a := I2STreeNode new.
	a maxChildren: 2.
	a maxValues: 1.
	
self should: [a getValueAt: 0] raise: Error.
self shouldnt: [a getValueAt: 1] raise: Error.
self should: [a getValueAt: 2] raise: Error.
self should: [a setValue: 0 at: 0] raise: Error.
self shouldnt: [a setValue: 0 at: 1] raise: Error.
self should: [a setValue: 0 at: 2] raise: Error.
self should: [a getChildAt: 0] raise: Error.
self shouldnt: [a getChildAt: 1] raise: Error.
self shouldnt: [a getChildAt: 2] raise: Error.
self should: [a getChildAt: 3] raise: Error.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:13:41.649'!
test03Children
	| a b c |
	a := I2STreeNode new.
	b := I2STreeNode new.
	c := I2STreeNode new.
	
	a addChild: b at: 1.
	self assert: b equals: (a getChildAt: 1).
	self should: [a addChild: b at: 2] raise: Error.
	self should: [a addChild: c at: 1] raise: Error.
	a addChild: c at: 2.
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (b parent).
	self assert: a equals: (c parent).
	
	a removeChildAt: 1.
	self assert: ((a getChildAt: 1) isNil).
	self assert: (b parent isNil).
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (c parent).
	a removeChildAt: 2.
	self assert: (a getChildAt: 2) isNil.
	self assert: c parent isNil.
	
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:57:07.369'!
test04ChildrenAndLimits
	| a b |
	a := I2STreeNode new.
	b := I2STreeNode new.
	a maxChildren: 1.
	
	self should: [ a addChild: b at: 0] raise: Error.
	self should: [ a addChild: b at: 2] raise: Error.
	self shouldnt: [ a addChild: b at: 1] raise: Error.
	
	self should: [a removeChildAt: 0] raise: Error.
	self should: [a removeChildAt: 2] raise: Error.
	self shouldnt: [a removeChildAt: 1] raise: Error.
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 14:29:06.552'!
test05BinaryTree
	| a b c |
	a := I2SBinaryTreeNode newWithValue: 5.
	self assert: 1 equals: a maxValues.
	self assert: 2 equals: a maxChildren.
	self assert: 5 equals: a value.
	
	b := I2SBinaryTreeNode newWithValue: 3.
	c := I2SBinaryTreeNode newWithValue: 7.
	
	a leftChild: b.
	self assert: b equals: a leftChild.
	a leftChild: c.
	self assert: c equals: a leftChild.
	a rightChild: b.
	self assert: b equals: a rightChild.
	
	c value: 8.
	self assert: 8 equals: c value.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:16:59.938'!
test06BinarySearchTree
	| root |
	root := I2SBinarySearchTreeNode newWithValue: 5.
	root addValue: 3.
	root addValue: 7.
	root addValue: 14.
	root addValue: 4.
	
	self assert: 5 equals: root value.
	self assert: 3 equals: root leftChild value.
	self assert: 7 equals: root rightChild value.
	self assert: 14 equals: root rightChild rightChild value.
	self assert: (root leftChild leftChild) isNil.
	self assert: (root rightChild leftChild) isNil.
	self assert: (root find: 5).
	self assert: (root find: 7).
	self assert: (root find: 3).
	self assert: (root find: 14).
	self assert: (root find: 4).
	self assert: (root find: 20) not.
	self assert: (root find: 10) not.
	self assert: (root find: 0) not.! !

TestCase subclass: #I2SVisualizationTests
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:50:14.849'!
setUp
	
	super setUp.
	visualization := I2SVisualization new. 
	! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 11:44:04.316'!
tearDown
	
	visualization delete.
	super tearDown! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:28:54.794'!
test01SimpleTree
	| a b c |
	a := I2STreeNode new.
	a setValue: Color red at: 1.

	b := I2STreeNode new.
	b setValue: Color blue at: 1.

	c := I2STreeNode new.
	c setValue: Color blue at: 1.

	a addChild: b at: 1.
	a addChild: c at: 2.

	(visualization setRootNode: a)	openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:32:18.954'!
test02UpdateTree

	| root child |
	root := I2STreeNode new.
	
	(visualization setRootNode: root) openInWorld.
	
	child := I2STreeNode new.
	
	root addChild: child at: 1.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:30:58.813'!
test03RemoveChild

	| root child |
	root := I2STreeNode new.
			
	child := I2STreeNode new.
	
	root addChild: child at: 1.
	
	(visualization setRootNode: root) openInWorld.
		
	root removeChildAt: 1.
! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:29:32.808'!
test04MoarDepth
	| a b c d |
	a := I2STreeNode new.

	b := I2STreeNode new.

	c := I2STreeNode new.
	
	d := I2STreeNode new.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	
	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:40:37.672'!
test05ComplexTree

| a b c d e f |
	a := I2STreeNode new.
	a color: Color red.

	b := I2STreeNode new.
	b color: Color blue.

	c := I2STreeNode new.
	c color: Color blue.

	d := I2STreeNode new.
	e := I2STreeNode new.
	f := I2STreeNode new.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	b addChild: e at: 2.
	c addChild: f at: 1.

	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:41:25.401'!
testBuildBinaryTreeFromRoot

	| root nodeOne nodeTwo |
	root := I2SBinaryTreeNode new.
	nodeOne := I2SBinaryTreeNode new.
	nodeTwo := I2SBinaryTreeNode new.
	
	root color: Color red.
	
	root rightChild: nodeOne.
	nodeOne rightChild: nodeTwo.
	
	(visualization setRootNode: root) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:47:17.087'!
testDefaultColor
	
	| node description|
	node := I2STreeNode new.
	visualization setRootNode: node.
	
	description := 'Every node needs a default color for visualization.'.
	self assert: 
		[(visualization getVisualNodeFor: node) color = Color orange]
		description: description.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:39:33.432'!
testVisualizationAssignment

	| root child child2 child3 aTreeNode|
	
	root := I2STreeNode new.
	child := I2STreeNode new.
	child2 := I2STreeNode new.
	child3 := I2STreeNode new.
	
	root addChild: child at: 1.
	root addChild: child2 at: 2.
	child2 addChild: child3 at: 1.
	
	(visualization setRootNode: root) openInWorld.
	self assert: (visualization submorphs at: 1) 
		equals: (visualization getVisualNodeFor: root).

	"Is there a better, more stable way to test this?"
	self assert: ((visualization getVisualNodeFor: root) 
						submorphs at: 4)
		equals: (visualization getVisualNodeFor: child).
	
	self assert: (((visualization getVisualNodeFor: root)
						submorphs at: 2) submorphs at: 2)
		equals: (visualization getVisualNodeFor: child3).
	
	"less moph-structure dependent approach"
	aTreeNode := (visualization getVisualNodeFor: child3) node.
	self assert: root equals: 
		aTreeNode parent parent.
	
	! !
